/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include    <iomanip>
#include    <iostream>
#include    <sstream>

using namespace std;

#define     fdRead      0
#define     fdWrite     1

int main(int argc, char** argv)
{
  unsigned char     bytes[200];
  unsigned int      data;
  unsigned int      idx;
  string            line;

  while( getline(cin, line) )
  { 
      stringstream  strm( line );
      idx   = 0;
      
      while( strm >> std::hex >> data )
      {
        bytes[idx]  = data;
        idx++;
        if( idx >= sizeof(bytes) / sizeof(bytes[0]) )
        {
          return    -1;
        }
      }

      switch( bytes[2] )
      {
        case 0x9:
        {
          cout << endl << "req ";
          break;
        }
        case 0xa:
        {
          cout << "res ";
          break;
        }
        case 0xb:
        {
          cout << "ack ";
          break;
        }
        case 0xc:
        {
          cout << "bsy ";
          break;
        }
        default:
        {
          continue;
        }
      }
      
      cout << setfill('0');
      cout << setw(2) << hex << (int)bytes[4] << " ";
      
      cout << setfill(' ');
      cout << setw(2) << dec << (int)bytes[1] << " -> " << setw(2) << dec << (int)bytes[0] << " ";
            
      cout << setfill('0');
      for( unsigned int i = 5; i < idx; i++ )
      {
        cout << setw(2) << hex << (int)bytes[i];
        cout << " ";
      }

      cout << endl;
  }
  
  return    0;
}

