/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/**
 * QP dS485 signals
 * Q_USER_SIG is 4 ...
 */
#define SIGNAL_OFFSET_DS485        1

enum D485Signals {
    START_SIG = Q_USER_SIG + SIGNAL_OFFSET_DS485,
    CONFIG_INIT_SIG,
    TERMINATE_SIG,
    SYSTEM_TERM_SIG,
    DS485_INITIAL_TIMEOUT_SIG,
    DS485_JOIN_RESPONSE_TIMEOUT_SIG,
    DS485_ADDRESS_SIG,
    DS485_STOPPED_SIG,

    DS485_STARTUP_TIMEOUT_SIG,
    DS485_RX_TOKEN_SIG,
    DS485_RX_STARTUP_SIG,
    DS485_RX_JOIN_SIG,
    DS485_RX_GET_ADDRESS_SIG,
    DS485_RX_SET_ADDRESS_SIG,
    DS485_RX_SET_SUCCESSOR_ADDRESS_SIG,
    DS485_RX_RESPONSE_SIG,
    DS485_RX_DATA_SIG,
    DS485_RX_RESTART_BUS_SIG,
    DS485_TX_MSG_TIMEOUT_SIG,
    DS485_TOKEN_MIN_HOLD_TIMEOUT_SIG,
    DS485_TOKEN_MAX_HOLD_TIMEOUT_SIG,
    DS485_HAND_OVER_TOKEN_TIMEOUT_SIG,
    DS485_TOKEN_MISSING_TIMEOUT_SIG,
    DS485_REGISTER_STATION_TIMEOUT_SIG,
    DS485_TRANSMIT_DATA_TIMEOUT_SIG,
    DS485_FIND_STATION_TIMEOUT_SIG,
    DS485_TX_MSG_SIG,
    DS485_TX_RESTART_BUS_SIG,

    DS485_RESET_STATISTICS_SIG,
    DS485_REQ_STATISTICS_SIG,
    DS485_RES_STATISTICS_SIG,
    DS485_REQ_BUS_MEMBERS_SIG,
    DS485_RES_BUS_MEMBERS_SIG,

    RX_OTHER_BYTE_SIG,
    RX_START_BYTE_SIG,
    RX_ESCAPE_BYTE_SIG,
    RX_DATA_BYTE_SIG,
    RX_RESERVED_BYTE_SIG,
    DS485_RX_MSG_TIMEOUT_SIG,

    RESPONSE_TIMEOUT_SIG,

    MMI_REQ_BUS_STATE_SIG,
    MMI_RES_BUS_STATE_SIG,
    MMI_DS485_DEVICE_REGISTERED_SIG,
    MMI_DS485_DEVICE_ADDRESS_SIG,
    MMI_DS485_DEVICE_LOST_SIG,
    MMI_DS485_STATE_SIG,
    MMI_DS485_DSUID_REGISTRED_SIG,
    MMI_DS485_DSUID_DEREGISTRED_SIG,

    MAX_PUBLISH_SIG,
};

